---
title: Overview
---

# Project status as of 1.0.0

> This section was written in September 2022, to describe our status at the time.
> We intend to revise it with our next major feature release.

Arti reached version 1.0.0, a significant milestone in the development of this Tor implementation. With this release, we consider Arti suitable for real-world use to ensure the privacy and anonymity of connections.
It can now successfully connect to the Tor network, bootstrap a view of the Tor directory, and establish anonymized connections over the network.

### Key Features and Achievements:

- Tor Network Connectivity: Arti has demonstrated the capability to connect seamlessly to the Tor network, allowing users to access the network for secure and anonymous communication.

- Directory Bootstrapping: The project has successfully implemented the functionality to bootstrap a view of the Tor directory, a critical component for efficient and secure Tor network operations.

- Anonymized Connections: Arti facilitates anonymized connections over the Tor network, ensuring that user communications are private and protected from surveillance.

### Areas of Attention:

Despite the significant progress with the release of Arti v1.0.0, it's crucial to acknowledge some ongoing considerations:

- API Stability: In certain areas, especially at the lower layers, some APIs (particularly internal APIs) are not yet stable. We anticipate ongoing changes and improvements to enhance the overall reliability and functionality of Arti.

- Command Line Interface (CLI): The command line interface to the Arti program is currently undergoing development, and changes are expected. Users should be aware that improvements and modifications to the CLI are likely in subsequent releases.

- Early Stage: As a relatively new release, Arti is in its early stages of development. Users should be prepared for the possibility of encountering bugs and are encouraged to report any issues to contribute to ongoing refinements.

### What’s next for Arti?

The development team is committed to addressing the areas of attention highlighted above. The focus will be on refining APIs, stabilizing the CLI, and actively addressing bug reports to enhance the overall user experience.
We encourage users to provide feedback, report issues, and actively participate in the community to contribute to the continued improvement of Arti.
